!******************************************************************************!
!                                                                              !
!    ctparameter5.f90                                                          !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016,2017 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter5.f90                               |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-01-12 12:33             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter5
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter5()
  if (dMC_QED2_scheme .eq. 0) then
    dMC_QED2 = (2d0*Ten182*cMC*coupl(nGC_2)**2d0 + Ten183*cMC*(-2d0*coupl(     &
               nGC_35)**2d0 + 8d0*coupl(nGC_35)*coupl(nGC_39) - 2d0*coupl(     &
               nGC_39)**2d0 - coupl(nGC_58)**2d0 - 2d0*coupl(nGC_58)*coupl(    &
               nGC_60) - coupl(nGC_60)**2d0)/2d0 - Ten184*(2d0*cMC*coupl(nGC_23&
               )**2d0 + cMC*coupl(nGC_57)**2d0 + cMC*coupl(nGC_73)**2d0 + 2d0* &
               cMS*coupl(nGC_57)*coupl(nGC_73))/2d0 + Ten185*cMC*coupl(nGC_59  &
               )**2d0 - 2d0*Ten186*cMC*coupl(nGC_2)**2d0 - Ten187*cMC*(coupl(  &
               nGC_35)**2d0 + coupl(nGC_39)**2d0 + coupl(nGC_58)*coupl(nGC_60  &
               )) - Ten188*cMC*(2d0*coupl(nGC_23)**2d0 + coupl(nGC_57)**2d0 +  &
               coupl(nGC_73)**2d0)/2d0 - Ten189*cMC*coupl(nGC_59)**2d0 + 2d0*  &
               Ten190*cMC*coupl(nGC_59)**2d0*rMC*(-cMC + rMC) + 4d0*Ten191*    &
               coupl(nGC_2)**2d0*rMC*(2d0*cMC**2d0 - 3d0*cMC*rMC + rMC**2d0) + &
               Ten192*rMC*(8d0*cMC**2d0*coupl(nGC_35)*coupl(nGC_39) - cMC**2d0*&
               coupl(nGC_58)**2d0 - cMC**2d0*coupl(nGC_60)**2d0 - 2d0*cMC*coupl&
               (nGC_35)**2d0*rMC - 8d0*cMC*coupl(nGC_35)*coupl(nGC_39)*rMC -   &
               2d0*cMC*coupl(nGC_39)**2d0*rMC + cMC*coupl(nGC_58)**2d0*rMC -   &
               2d0*cMC*coupl(nGC_58)*coupl(nGC_60)*rMC + cMC*coupl(nGC_60)**2d0&
               *rMC + 2d0*coupl(nGC_35)**2d0*rMC**2d0 + 2d0*coupl(nGC_39)**2d0*&
               rMC**2d0 + 2d0*coupl(nGC_58)*coupl(nGC_60)*rMC**2d0) + Ten193*  &
               rMC*(-2d0*cMC*cMS*coupl(nGC_57)*coupl(nGC_73) - 2d0*cMC*coupl(  &
               nGC_23)**2d0*rMC - cMC*coupl(nGC_57)**2d0*rMC - cMC*coupl(nGC_73&
               )**2d0*rMC + 2d0*cMS*coupl(nGC_57)*coupl(nGC_73)*rMC + 2d0*coupl&
               (nGC_23)**2d0*rMC**2d0 + coupl(nGC_57)**2d0*rMC**2d0 + coupl(   &
               nGC_73)**2d0*rMC**2d0) + 2d0*Ten194*coupl(nGC_59)**2d0*rMC**2d0 &
               *(cMC - rMC) + 4d0*Ten195*coupl(nGC_2)**2d0*rMC**2d0*(-cMC + rMC&
               ) + 2d0*Ten196*rMC**2d0*(-cMC*coupl(nGC_35)**2d0 - cMC*coupl(   &
               nGC_39)**2d0 - cMC*coupl(nGC_58)*coupl(nGC_60) + coupl(nGC_35)**&
               2d0*rMC + coupl(nGC_39)**2d0*rMC + coupl(nGC_58)*coupl(nGC_60)* &
               rMC) + Ten197*rMC**2d0*(-2d0*cMC*coupl(nGC_23)**2d0 - cMC*coupl(&
               nGC_57)**2d0 - cMC*coupl(nGC_73)**2d0 + 2d0*coupl(nGC_23)**2d0* &
               rMC + coupl(nGC_57)**2d0*rMC + coupl(nGC_73)**2d0*rMC) + (-64d0*&
               pi*aEW*cMC**2d0 + 64d0*pi*aEW*rMC**2d0 - 18d0*cMC*coupl(nGC_2)**&
               2d0*rMC + 9d0*cMC*coupl(nGC_23)**2d0*rMC + 9d0*cMC*coupl(nGC_35 &
               )**2d0*rMC - 36d0*cMC*coupl(nGC_35)*coupl(nGC_39)*rMC + 9d0*cMC*&
               coupl(nGC_39)**2d0*rMC)/(18d0*rMC))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMC_QED2 = cone*real(dMC_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter5
end module ctparameter5
