!******************************************************************************!
!                                                                              !
!    lcFVFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016,2017 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcFVFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-01-12 12:33             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcFVFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec
  contains
    subroutine loopFVFa(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn,      &
    riMaxOut, rankInc)
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(FVFa0)
!       GammaM(2,3,1)*c0
!       GammaP(2,3,1)*c1
        pl(:) = PL1(:) + PL2(:)
        x1 = cima*w2(1)
        x2 = w2(0) + w2(3)
        x5 = co(0)*m
        x22 = w2(2) + x1
        x23 = w2(0) - w2(3)
        do j = riMaxIn, 0, -1
          x0 = co(1)*wl(0,j)
          x3 = wl(2,j)*x2
          x4 = cima*x3
          x6 = co(1)*wl(1,j)
          x7 = w2(1)*wl(2,j)
          x8 = w2(0)*wl(3,j) - w2(3)*wl(3,j) + x7
          x9 = w2(2)*wl(2,j)
          x10 = -x9
          x11 = pl(1)*wl(3,j)
          x12 = w2(1)*wl(1,j)
          x13 = w2(3)*wl(0,j)
          x14 = w2(0)*wl(0,j)
          x15 = w2(2)*wl(1,j)
          x16 = co(1)*(cima*(x12 + x13 - x14) + x15)
          x17 = pl(2)*wl(3,j)
          x18 = w2(2)*wl(0,j)
          x19 = wl(1,j)*x2
          x20 = cima*x19
          x21 = co(1)*(-wl(0,j)*x1 + x18 + x20)
          x24 = co(1)*(-wl(0,j)*(-w2(2) + x1) + x20)
          x25 = co(0)*(wl(3,j)*x22 + x4)
          x26 = wl(3,j)*x23 + x7
          x27 = co(0)*(cima*x26 + x10)
          wp(0,j) = cima*(pl(0)*(w2(0)*x0 - w2(1)*x6 - w2(3)*x0) - pl(3)*w2(1)*&
                    x0 + pl(3)*x2*x6) - pl(0)*w2(2)*x6 + pl(3)*w2(2)*x0 - x5*( &
                    wl(3,j)*(w2(2) + x1) + x4)
          wp(1,j) = -cima*(pl(1)*w2(1)*x0 - pl(1)*x2*x6 + pl(2)*(-w2(0)*x0 + w2&
                    (1)*x6 + w2(3)*x0) + x5*x8) + pl(1)*w2(2)*x0 - pl(2)*w2(2)*&
                    x6 - x10*x5
          wp(2,j) = co(0)*(cima*pl(1)*x3 - cima*pl(3)*x8 + cima*w2(1)*x11 + pl(&
                    3)*w2(2)*wl(2,j) + w2(2)*x11) + m*x16
          wp(3,j) = -co(0)*(-cima*pl(0)*x8 + cima*pl(2)*x3 + cima*w2(1)*x17 +  &
                    pl(0)*w2(2)*wl(2,j) + w2(2)*x17) - m*x21
          if(rankInc .lt. 1) cycle
          sp2(0,0) = cima*co(1)*wl(0,j)*x23 - co(1)*wl(1,j)*x22
          sp2(0,1) = x24
          sp2(0,2) = x25
          sp2(0,3) = x27
          sp2(1,0) = -x21
          sp2(1,1) = x16
          sp2(1,2) = x27
          sp2(1,3) = x25
          sp2(2,0) = cima*co(1)*x18 + co(1)*w2(1)*wl(0,j) - co(1)*x19
          sp2(2,1) = cima*co(1)*x15 - co(1)*x12 - co(1)*x13 + co(1)*x14
          sp2(2,2) = cima*co(0)*x9 + co(0)*x26
          sp2(2,3) = cima*co(0)*w2(2)*wl(3,j) - co(0)*w2(1)*wl(3,j) - co(0)*x3
          sp2(3,0) = x16
          sp2(3,1) = x24
          sp2(3,2) = x25
          sp2(3,3) = -x27
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + sp2(mu,:)
          end do 
        end do 
      case(FVFa1)
!       GammaM(2,3,1)*c0
        pl(:) = PL1(:) + PL2(:)
        x0 = cima*w2(1)
        x10 = cima*w2(2)
        do j = riMaxIn, 0, -1
          x1 = wl(2,j)*(w2(0) + w2(3))
          x2 = cima*x1
          x3 = w2(1)*wl(2,j)
          x4 = wl(3,j)*(w2(0) - w2(3)) + x3
          x5 = co(0)*(cima*x4 - w2(2)*wl(2,j))
          x6 = w2(0)*wl(3,j) - w2(3)*wl(3,j) + x3
          x7 = pl(1)*wl(3,j)
          x8 = pl(2)*wl(3,j)
          x9 = co(0)*(wl(3,j)*(w2(2) + x0) + x2)
          wp(0,j) = -co(0)*m*(wl(3,j)*(w2(2) + x0) + x2)
          wp(1,j) = -m*x5
          wp(2,j) = co(0)*(cima*pl(1)*x1 - cima*pl(3)*x6 + cima*w2(1)*x7 + pl(3&
                    )*w2(2)*wl(2,j) + w2(2)*x7)
          wp(3,j) = -co(0)*(-cima*pl(0)*x6 + cima*pl(2)*x1 + cima*w2(1)*x8 + pl&
                    (0)*w2(2)*wl(2,j) + w2(2)*x8)
          if(rankInc .lt. 1) cycle
          sp2(0,0) = 0
          sp2(0,1) = 0
          sp2(0,2) = x9
          sp2(0,3) = x5
          sp2(1,0) = 0
          sp2(1,1) = 0
          sp2(1,2) = x5
          sp2(1,3) = x9
          sp2(2,0) = 0
          sp2(2,1) = 0
          sp2(2,2) = co(0)*wl(2,j)*x10 + co(0)*x4
          sp2(2,3) = -co(0)*w2(1)*wl(3,j) + co(0)*wl(3,j)*x10 - co(0)*x1
          sp2(3,0) = 0
          sp2(3,1) = 0
          sp2(3,2) = x9
          sp2(3,3) = -x5
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + sp2(mu,:)
          end do 
        end do 
      end select 
    end subroutine loopFVFa
end module lcFVFa
